Coin: SoGLShaderProgramElement Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
SoGLShaderProgramElement Class Reference
Inheritance diagram for SoGLShaderProgramElement:

## Public Member Functions
virtual void | init (SoState *state)
virtual void | push (SoState *)
virtual void | pop (SoState *state, const SoElement *prevTopElement)
virtual SbBool | matches (const SoElement *element) const
virtual SoElement * | copyMatchInfo () const
Public Member Functions inherited from SoReplacedElement
SbUniqueId | getNodeId () const
virtual void | print (FILE *file) const
Public Member Functions inherited from SoElement
const SoType | getTypeId (void) const
int | getStackIndex (void) const
void | setDepth (const int depth)
int | getDepth (void) const
virtual | ~SoElement ()

## Static Public Member Functions
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | enable (SoState *const state, const SbBool onoff)
static void | set (SoState *const state, SoNode *const node, SoGLShaderProgram *program)
static SoGLShaderProgram * | get (SoState *state)
static void | initClass (void)
Static Public Member Functions inherited from SoReplacedElement
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initClass (void)
Static Public Member Functions inherited from SoElement
static void | initClass (void)
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initElements (void)
static int | getNumStackIndices (void)
static SoType | getIdFromStackIndex (const int stackIndex)

## Public Attributes
SoGLShaderProgram * | shaderProgram

## Additional Inherited Members
Protected Member Functions inherited from SoReplacedElement
virtual | ~SoReplacedElement ()
Protected Member Functions inherited from SoElement
| SoElement (void)
void | capture (SoState *const state) const
virtual void | captureThis (SoState *state) const
void | setTypeId (const SoType typeId)
void | setStackIndex (const int index)
SoElement * | getNextInStack (void) const
SoElement * | getNextFree (void) const
Static Protected Member Functions inherited from SoReplacedElement
static SoElement * | getElement (SoState *const state, const int stackIndex, SoNode *const node)
Static Protected Member Functions inherited from SoElement
static SoElement * | getElement (SoState *const state, const int stackIndex)
static const SoElement * | getConstElement (SoState *const state, const int stackIndex)
static int | createStackIndex (const SoType id)
Protected Attributes inherited from SoReplacedElement
SbUniqueId | nodeId
Protected Attributes inherited from SoElement
SoType | typeId
int | stackIndex
int | depth
Static Protected Attributes inherited from SoElement
static int | classStackIndex
static SoTypeList * | stackToType

## Member Function Documentation

## ◆ init()

virtual void SoGLShaderProgramElement::init | ( | SoState * | state | ) |
| virtual

This function initializes the element type in the given SoState. It is called for the first element of each enabled element type in SoState objects.

Reimplemented from SoReplacedElement.

## ◆ push()

virtual void SoGLShaderProgramElement::push | ( | SoState * | state | ) |
| virtual

This method is called every time a new element is required in one of the stacks. This happens when a writable element is requested, using SoState::getElement() or indirectly SoElement::getElement(), and the depth of the current element is less than the state depth.

Override this method if your element needs to copy data from the previous top of stack. The push() method is called on the new element, and the previous element can be found using SoElement::getNextInStack().

Reimplemented from SoElement.

## ◆ pop()

virtual void SoGLShaderProgramElement::pop | ( | SoState * | state,
|  | const SoElement * | prevTopElement )
| virtual

This method is called when the state is popped, and the depth of the element is bigger than the current state depth. pop() is called on the new top of stack, and a pointer to the previous top of stack is passed in prevTopElement.

Override this method if you need to copy some state information from the previous top of stack.

Reimplemented from SoElement.

## ◆ matches()

virtual SbBool SoGLShaderProgramElement::matches | ( | const SoElement * | element | ) | const
| virtual

This function returns `TRUE` is the element matches another element (of the same class), with respect to cache validity.

If the application programmer's extension element has a matches() function, it should also have a copyMatchInfo() function.

Reimplemented from SoReplacedElement.

## ◆ copyMatchInfo()

virtual SoElement * SoGLShaderProgramElement::copyMatchInfo | ( | void |  | ) | const
| virtual

This function creates a copy of the element that contains enough information to enable the matches() function to work.

Used to help with scene graph traversal caching operations.

Reimplemented from SoReplacedElement.

The documentation for this class was generated from the following file:

- SoGLShaderProgramElement.h